<template>
    <v-card>
        <v-card-text>
            <v-data-table
                    :headers="headers"
                    :items="items"
                    :item-key="itemKey"
                    v-model="selected"
                    :select-all="selectable"
                    :pagination.sync="pagination"
                    :total-items="totalItems"
                    :loading="loading"
                    :rows-per-page-items="[10, 25, 50, 100, { text: $t('All'), value: -1 }]"
                    :rows-per-page-text="$t('Rows per page')"
            >

                <template slot="items" slot-scope="props">
                    <tr :active="props.selected" :class="getRowClass(props.item)">
                        <td v-if="selectable">
                            <v-checkbox
                                    primary
                                    hide-details
                                    v-model="props.selected"
                            ></v-checkbox>
                        </td>
                        <slot name="data" :item="props.item">
                            <td v-for="h in headers" :key="h.value" :class="h.alignClass" v-if="h.value !== '__actions'">
                                <template v-if="h.type">
                                    <data-grid-cell :header="h" :item="props.item" :idKey="itemKey"></data-grid-cell>
                                </template>
                                <template v-else>
                                    {{ props.item[h.value]}}
                                </template>
                            </td>
                        </slot>

                        <td class="justify-center layout px-0" v-if="hasActions">
                            <slot name="actions" :item="props.item" v-if="hasActions"></slot>
                        </td>
                    </tr>
                </template>

                <template slot="no-data">
                    <v-alert :value="true" color="warning" icon="warning" v-if="loaded">
                        {{ $t('No data available') }}
                    </v-alert>
                </template>

                <template slot="footer">
                    <td colspan="100%">
                        <v-layout row align-center>
                            <v-flex>
                                <small v-if="selectable" class="grey--text text--darken-1">
                                    {{ $t('Selected') }}: {{selectedCount}}
                                </small>
                            </v-flex>
                            <v-flex class="text-xs-right" v-if="pages>1">
                                <v-pagination v-model="pagination.page" :length="pages" :total-visible="7"></v-pagination>
                            </v-flex>
                        </v-layout>
                    </td>
                </template>

                <template slot="pageText" slot-scope="props">
                    {{ props.pageStart }} - {{ props.pageStop }} {{$t('of')}} {{ props.itemsLength }}
                </template>

            </v-data-table>
        </v-card-text>
    </v-card>
</template>

<script>
    let source = null;

    export default {
        data: () => ({
            search: '',
            totalItems: 0,
            items: [],
            loading: false,
            pagination: { rowsPerPage: 10 },
            loaded: false,
            selected: [],
            headers: [],
            tools: null,
            pages: 0,
            itemExpressions: {}
        }),

        props: {
            url: {
                type: String
            },
            itemKey: {
                default: 'id',
                type: String
            },
            selectable: {
                default: false,
                type: Boolean
            },
            hasActions: {
                default: true,
                type: Boolean
            }
        },

        watch: {
            params: {
                handler (val, oldVal) {
                    //if (JSON.stringify(val) !== JSON.stringify(oldVal)) {
                        this.loadData();
                    //}
                },
                deep: true
            }
        },

        methods: {
            loadData () {
                if (!this.url) {
                    return;
                }

                if (source) {
                    source.cancel();
                }

                this.loading = true;

                source = axios.CancelToken.source();

                this.selected = [];

                const params = Object.assign({
                    withHeaders: this.headers.length > 0 ?  0 : 1
                }, this.params);

                if (this.search) {
                    params.search = this.search;
                }

                axios.get(this.url, {
                    params,
                    cancelToken: source.token
                }).then((response) => {
                    this.loading = false;

                    let data = response.data;

                    if (data.headers) {
                        this.headers = data.headers.map(header => {
                            header.align = header.align || 'left';
                            if (header.align !== 'left') {
                                header.alignClass = 'text-xs-' + header.align;
                            }
                            return header;
                        });

                        if (this.hasActions) {
                            this.headers.push({
                                text: '',
                                value: '__actions',
                                alignClass: 'text-xs-right'
                            })
                        }

                        if (data.params) {
                            if (data.params.itemExpressions) {
                                this.itemExpressions = data.params.itemExpressions;
                            }
                        }

                        this.loaded = true;
                    }

                    this.items = data.items;
                    this.totalItems = data.total;
                    this.pages = data.pages;
                }).catch((e) => {
                    if (!axios.isCancel(e)) {
                        this.loading = false;
                    }
                });
            },

            getItem(id) {
                for (let i = 0; i < this.items.length; i++) {
                    if (this.items[i][this.itemKey] === id) {
                        return this.items[i];
                    }
                }

                return null;
            },

            deleteItem(item) {
                let i = this.items.indexOf(item);
                if (i >= 0) {
                    this.items.splice(i, 1);
                    let i = this.selected.indexOf(item);
                    if (i >= 0) {
                        this.selected.splice(i, 1);
                    }
                }
            },

            deleteItems(id) {
                const ids = Array.isArray(id) ? id : [id];
                this.items = this.items.filter(item => ids.indexOf(item[this.itemKey]) === -1);
                this.selected = this.selected.filter(item => ids.indexOf(item[this.itemKey]) === -1);
            },

            updateItem(id, data) {
                let item = this.getItem(id);
                if (item) {
                    const i = this.items.indexOf(item);
                    this.$set(this.items, i, Object.assign({}, item, data));
                }
            },

            bulkAction(url, confirmation, data) {
                if (confirmation) {
                    const confirmText = typeof confirmation === 'string' ? confirmation : this.$t('Confirm');
                    if (!confirm(confirmText)) {
                        return new Promise((resolve, reject) => {
                            reject(false);
                        });
                    }
                }

                let params = data || {};
                params.id = this.selectedIds;

                this.loading = true;

                return axios.post(url, params)
                    .then(r => {
                        this.loading = false;
                        return r;
                    })
                    .catch(e => {
                        this.loading = false;
                        return e;
                    });
            },

            bulkDelete(url, confirmation) {
                this.bulkAction(url, confirmation)
                    .then(r => {
                        if (r.data) {
                            this.deleteItems(r.data);
                        }
                    }).catch(e => e);
            },

            bulkUpdate(url, data, confirmation) {
                this.bulkAction(url, confirmation, data)
                    .then(r => {
                        if (r.data && r.data.length) {
                            for (let item of r.data) {
                                const id = item[this.itemKey];
                                if (id) {
                                    this.updateItem(id, item);
                                }
                            }
                        }
                    }).catch(e => e);
            },

            action(url, item, confirmation, data) {
                if (confirmation) {
                    const confirmText = typeof confirmation === 'string' ? confirmation : this.$t('Confirm');
                    if (!confirm(confirmText)) {
                        return new Promise((resolve, reject) => {
                            reject(false);
                        });
                    }
                }

                let params = data || {};
                params.id = item[this.itemKey];

                this.loading = true;
                item.__loading = true;

                return axios.post(url, params)
                    .then(r => {
                        this.loading = false;
                        item.__loading = false;

                        if (r.data && r.data.item) {
                            Object.assign(item, r.data.item);
                        }
                        return r;
                    })
                    .catch(e => {
                        this.loading = false;
                        item.__loading = false;
                        return e;
                    });
            },

            delete(url, item, confirmation) {
                this.action(url, item, confirmation)
                    .then(r => {
                        if (r.data) {
                            this.deleteItems(r.data);
                        }
                    }).catch(e => {

                });
            },

            itemUrl(url, item) {
                return url + '/' + item[this.itemKey];
            },

            getRowClass(item) {
                return this.itemExpression(item, 'rowClass');
            },

            itemExpression(item, name) {
                if (this.itemExpressions[name]) {
                    let result = null;
                    eval('result = ' + this.itemExpressions[name] + ';');
                    return result;
                }
            }
        },

        computed: {
            selectedCount() {
                return this.selected.length;
            },

            hasSelected() {
                return this.selected.length > 0;
            },

            selectedIds() {
                return this.selected.map(item => item[this.itemKey]);
            },

            params() {
                return {
                    page: this.pagination.page || null,
                    sort: {
                        by: this.pagination.sortBy || null,
                        reverse: this.pagination.descending || null
                    },
                    perPage: this.pagination.rowsPerPage || null
                };
            }
        },

        destroyed() {
            if (source) {
                source.cancel();
            }
        }
    }
</script>

<style scoped>

</style>
